import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataKubernetesMutatingWebhookConfigurationV1Config extends cdktf.TerraformMetaArguments {
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#metadata DataKubernetesMutatingWebhookConfigurationV1#metadata}
    */
    readonly metadata: DataKubernetesMutatingWebhookConfigurationV1Metadata;
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookClientConfigService extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
    get path(): string;
    get port(): number;
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookClientConfig extends cdktf.ComplexComputedList {
    get caBundle(): string;
    get service(): cdktf.IResolvable;
    get url(): string;
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookNamespaceSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookNamespaceSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookObjectSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookObjectSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookRule extends cdktf.ComplexComputedList {
    get apiGroups(): string[];
    get apiVersions(): string[];
    get operations(): string[];
    get resources(): string[];
    get scope(): string;
}
export declare class DataKubernetesMutatingWebhookConfigurationV1Webhook extends cdktf.ComplexComputedList {
    get admissionReviewVersions(): string[];
    get clientConfig(): cdktf.IResolvable;
    get failurePolicy(): string;
    get matchPolicy(): string;
    get name(): string;
    get namespaceSelector(): cdktf.IResolvable;
    get objectSelector(): cdktf.IResolvable;
    get reinvocationPolicy(): string;
    get rule(): cdktf.IResolvable;
    get sideEffects(): string;
    get timeoutSeconds(): number;
}
export interface DataKubernetesMutatingWebhookConfigurationV1Metadata {
    /**
    * An unstructured key value map stored with the mutating webhook configuration that may be used to store arbitrary metadata. More info: http://kubernetes.io/docs/user-guide/annotations
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#annotations DataKubernetesMutatingWebhookConfigurationV1#annotations}
    */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
    * Map of string keys and values that can be used to organize and categorize (scope and select) the mutating webhook configuration. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#labels DataKubernetesMutatingWebhookConfigurationV1#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Name of the mutating webhook configuration, must be unique. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#name DataKubernetesMutatingWebhookConfigurationV1#name}
    */
    readonly name?: string;
}
export declare function dataKubernetesMutatingWebhookConfigurationV1MetadataToTerraform(struct?: DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference | DataKubernetesMutatingWebhookConfigurationV1Metadata): any;
export declare class DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined;
    set internalValue(value: DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined);
    private _annotations?;
    get annotations(): {
        [key: string]: string;
    };
    set annotations(value: {
        [key: string]: string;
    });
    resetAnnotations(): void;
    get annotationsInput(): {
        [key: string]: string;
    } | undefined;
    get generation(): number;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get resourceVersion(): string;
    get uid(): string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1 kubernetes_mutating_webhook_configuration_v1}
*/
export declare class DataKubernetesMutatingWebhookConfigurationV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1 kubernetes_mutating_webhook_configuration_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataKubernetesMutatingWebhookConfigurationV1Config
    */
    constructor(scope: Construct, id: string, config: DataKubernetesMutatingWebhookConfigurationV1Config);
    get id(): string;
    webhook(index: string): DataKubernetesMutatingWebhookConfigurationV1Webhook;
    private _metadata;
    get metadata(): DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference;
    putMetadata(value: DataKubernetesMutatingWebhookConfigurationV1Metadata): void;
    get metadataInput(): DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
